/******************************************************************************
 * @file     PDMA_INT0.c
 * @brief    PDMA ISR source file
 *
 * @note
 * Copyright (C) 2019 Nuvoton Technology Corp. All rights reserved.
*****************************************************************************/
#include "PDMA_INT0.h"
/*---------------------------------------------------------------------------*/
/* Global variables                                                          */
/*---------------------------------------------------------------------------*/
volatile uint8_t u8TxIdx=0, u8RxIdx=0;
uint32_t PDMA_Counter_1 = 0;
uint32_t PDMA_Counter_2 = 0;
uint32_t PDMA_Counter_3 = 0;
uint16_t PDMA_ErrorFlag = 0;
/*---------------------------------------------------------------------------*/
/* Functions                                                                 */
/*---------------------------------------------------------------------------*/
void PDMA_IRQHandler(void)
{
    uint32_t u32Status = PDMA_GET_INT_STATUS(PDMA);
    PDMA_Counter_1++;

    if(u32Status & 0x2) {
        if(PDMA_GET_TD_STS(PDMA) & 0x2) {           /* channel 1 done */
            /* Copy RX data to TX buffer */
            if(PDMA->CURSCAT[1] == (uint32_t)&DMA_RXDESC[0]) {
                for(int i=0; i<AUDIO_BLOCK_SIZE; i++) {
                    audio_buffer[i] = AUDIO_BUFFER_IN[i*2];
                }
            } else if(PDMA->CURSCAT[1] == (uint32_t)&DMA_RXDESC[1]) {
                for(int i=0; i<AUDIO_BLOCK_SIZE; i++) {
                    audio_buffer[i] = AUDIO_BUFFER_IN[AUDIO_BLOCK_SIZE*2 + i*2];
                }
            }
            u8CopyData = 1;
            u8RxIdx ^= 1;
            PDMA_Counter_2++;
            PDMA_CLR_TD_FLAG(PDMA, PDMA_TDSTS_TDIF1_Msk);
        }

        if(PDMA_GET_TD_STS(PDMA) & 0x4) {           /* channel 2 done */
            PDMA_Counter_3++;
            u8TxIdx ^= 1;
            PDMA_CLR_TD_FLAG(PDMA, PDMA_TDSTS_TDIF2_Msk);
        }
    } else {
        PDMA_CLR_ALIGN_FLAG(PDMA, PDMA_ABTSTS_ABTIF1_Msk);
        PDMA_ErrorFlag = 1;
    }
    //printf("unknown interrupt, status=0x%x!!\n", u32Status);
}
/*** (C) COPYRIGHT 2019 Nuvoton Technology Corp. ***/
