/******************************************************************************
 * @file     PDMA_INT0.h
 * @brief    PDMA interrupt header file
 *
 * @note
 * Copyright (C) 2019 Nuvoton Technology Corp. All rights reserved.
 ******************************************************************************/
#ifndef PDMA_INT0_H
#define PDMA_INT0_H

#include <stdio.h>
#include "NuMicro.h"
#include "def_real.h"
/*---------------------------------------------------------------------------*/
/* Define                                                                    */
/*---------------------------------------------------------------------------*/
/* AUDIO_BLOCK_SIZE is the number of audio samples in each recording window */
#define AUDIO_BLOCK_SIZE   (2*640)  // 640 = 16000*0.001*40: FRAME_LEN
#define BUFF_LEN        2560

void PDMA_IRQHandler(void);
extern DMA_DESC_T DMA_TXDESC[2], DMA_RXDESC[2];
extern int16_t audio_io_buffer[AUDIO_BLOCK_SIZE*8]; //2 (L/R) channels x 2 input/output x 2 for ping-pong buffer
extern int16_t audio_buffer[AUDIO_BLOCK_SIZE];
extern uint8_t u8CopyData;
extern uint16_t PDMA_ErrorFlag;
extern int16_t* AUDIO_BUFFER_IN;
extern int16_t* AUDIO_BUFFER_OUT;

#endif //PDMA_INT0_H
/*** (C) COPYRIGHT 2019 Nuvoton Technology Corp. ***/
